'' =================================================================================================
''          Cylon project by wirecutter
''
''   Origanal File....... jm_Demo_Board_Cylon.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.term
''   Started.... 
''   Updated.... 21 DEC 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  term : "fullduplexserial"


var

  long  WavCog 

  long  stack[64]


pub main | t, idx, delay, i

  term.start(RX1, TX1, %0000, 115_200)
  pause(1)

  term.tx(CLS)
  term.str(string("By your command:", CR, "-- Merry Christmas!"))

  dira[27..16] := %111111111111  'set the 12 portpins as output  
  delay := clkfreq / 1000 * (1506 / 14)                         ' file is 1.506s long

  repeat
    WavCog := cognew(playsound(10, @Cylon, 1), @stack) + 1
    t := cnt   
  'write data from DAT to 12 port pins
  
  repeat i from 0 to 63
      outa[27..16] := pattern1[i]  'write word from DAT to port
      waitcnt(clkfreq/17 + cnt)     'short delay

    repeat while WavCog                                         ' let sound finish
    pause(1)                                                    ' let cog unload

DAT
pattern1  word %100000001000, %010000001000, %001000001000, %000100001000, %000010001000, %000001001000, %000000101000, %000000011000 
          word %100000000100, %010000000100, %001000000100, %000100000100, %000010000100, %000001000100, %000000100100, %000000010100
          word %100000000010, %010000000010, %001000000010, %000100000010, %000010000010, %000001000010, %000000100010, %000000010010
          word %100000000001, %010000000001, %001000000001, %000100000001, %000010000001, %000001000001, %000000100001, %000000010001
          
pattern2  word %000000010001, %000000100001, %000001000001, %000010000001, %000100000001, %001000000001, %010000000001, %100000000001 
          word %000000010010, %000000100010, %000001000010, %000010000010, %000100000010, %001000000010, %010000000010, %100000000010
          word %000000010100, %000000100100, %000001000100, %000010000100, %000100000100, %001000000100, %010000000100, %100000000100
          word %000000011000, %000000101000, %000001001000, %000010001000, %000100001000, %001000001000, %010000001000, %100000001000
          
' a word has 16 bits, we use only the lower 12 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)

                                                                
pri playsound(pin, pntr, plays) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio (embedded WAV)
'' -- plays is number of plays before cog unloads itself

  if (plays =< 0)                                               ' if 0, play "forever"
    plays := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat plays
    addr := pntr + 44                                           ' skip over wav header
    t := cnt  
    repeat samples
      frqa := byte[addr++] << 24                                ' update dac
      waitcnt(t += rate)
      
  WavCog := 0                                                   ' alert forground
  cogstop(cogid)                                                ' unload cog


dat

                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"

                      
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}